.TH MRMAP 8 "3 July 1993"
.SH NAME
 mrmap \- map a DVMRP multicast backbone
.SH SYNOPSIS
.B mrmap
[
.I \-n
] [
.I \-a
] [
.I \-h
hops
] [
.I \-t
thresh
] [
.I \-r
retries
] [
.I \-T
timeout
]
\fIrouter\fR
.br
.SH DESCRIPTION
.I mrmap
can be used to `map' all or a portion of a DVMRP-based multicast
backbone such as the MBone.  It does this by doing a recursive,
depth-first tree-walk starting at multicast router
.I router.
.I Mrmap
can be used either stand-alone to determine the multicast topology or
in conjunction with
.I mrdebug(1)
to determine multicast routes.
.SH OPTIONS
.TP
.B \-a
follow all links.  Normally tunnels marked `down' or `disabled' are
not followed.
.TP
.B \-n
print only network numbers; don't try to translate IP addresses to
DNS names.
.TP
.BI \-h " hops"
only report on routers that are within
.I `hops'
hops of
.I `router'.
.TP
.BI \-t " thresh"
don't follow tunnels whose ttl threshhold is >=
.I thresh.
.SH OUTPUT FORMAT
The file format of
.I mrmap
was designed to be manipulated by normal Unix utilities (awk, sort, grep,
etc.).  To this end, there is one line output for each piece of
information gleaned from a remote multicast router.  Each output
line is `complete', i.e., the output file can be reordered or
subsetted without losing any information.  Also the files from
multiple runs of
.I mrmap
can be easily merged.  (It is our intention to eventually produce
tools that `intelligently' merge new information into an existing
.I mrmap
file so that the mbone can be mapped incrementally rather than
all at once.)
.LP
.I Mrmap
can produce four types of output lines.  The type is identified
by the first character of the line.  Each type of line has a fixed
number of fields and the fields are separated by whitespace (so
that awk and sort can easily operate on the file).  The types are:
.TP
> src dest [attr]
specifies a link from
.I src
to
.I dest
with attributes
.I [attr].
.I Src
and
.I dest
are router names, either in the form `hostname(ipaddr)' or `ipaddr'
(depending on the
.B \-n
flag).
The attributes are in the form `metric/threshhold/other_info' where
`other_info' is some combination of tunnel, srcrt, querier, down,
and disabled.
.TP
= src1 src2
says that
.I src1
and
.I src2
are two different interfaces on the same router.
.TP
! src v\fIn.n\fP
says that
.I src
is running version
.I n.n
of mrouted.
.TP
? src
says that
.I src
didn't respond to queries so its connectivity & metrics can't
be determined.
.SH USAGE
.B Mrmap
can be used to generate the input file for
.I mrdebug(1)
for multicast route debugging or can be used standalone to
determine the current multicast topology.  The
.B \-t
option is useful in the latter case to limit the mapping to
some subset of the mbone.  E.g., `mrmap -t 32 imr', where
.I imr
is an interior multicast router at some site, would map just
the multicast routers at that site (assuming that the site
follows the mbone convention of putting a threshhold of 32
at its boundary).
.SH AUTHOR
Van Jacobson (van@ee.lbl.gov) with inspiration from the map-mbone
program written by Pavel Curtis of Xerox PARC.
